<?php
Rhaco::import("contribute.generic.Automator");
Rhaco::importLibrary("SubScriptionBase");
Rhaco::importLibrary("FilterBase");
Rhaco::importLibrary("PublishBase");
/**
 * @author kazutaka tokushima
 * @license New BSD License
 * @copyright Copyright 2006- The Rhacophorus Project. All rights reserved.
 */
class Prhagger{
	function loadModule(){
		$variable	= array("subScription"=>array(),"filter"=>array(),"publish"=>array());

		foreach(FileUtil::getFileList(Rhaco::path("library/plugins")) as $file){
			if(Rhaco::importLibrary("plugins.".$file->originalName)){
				$object	= @eval(sprintf("return new %s();",$file->originalName));

				if(Variable::isClassType(SubScriptionBase,$object)){
					$variable["subscription"][$file->originalName] = $object;
				}else if(Variable::isClassType(SubScriptionBase,$object)){
					$variable["filter"][$file->originalName] = $object;
				}else if(Variable::isClassType(PublishBase,$object)){
					$variable["publish"][$file->originalName] = $object;
				}
			}
		}
		return $variable;
	}
	function execute($subscription,$filter,$publish){
		$automator = new Automator();

		foreach(Variable::toArray($subscription) as $name){
			$automator->add("Prhagger::toRss");
			$automator->add("plugins.".$name."::execute");
		}
		foreach(Variable::toArray($filter) as $name){
			$automator->add("Prhagger::toRss");
			$automator->add("plugins.".$name."::execute");
		}
		foreach(Variable::toArray($publish) as $name){
			$automator->add("Prhagger::toRss");
			$automator->add("plugins.".$name."::execute");
		}
		$automator->execute();
	}
	function toRss($rss){
		if(!Variable::isClassType(Rss20,$rss)){
			return new Rss20();
		}
		return $rss;
	}
}
?>